//DeathDeathIonCannon.cs

//audio
datablock AudioProfile(DeathIonCannonShot1Sound)
{
   filename    = "./Sound/IonCannonFire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(bulletHitSound)
{
   filename    = "./Sound/IonCannonLaserHit.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(DeathIonCannonSwitchSound)
{
   filename    = "./Sound/IonCannonSwitch.wav";
   Description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(DeathIonCannonChargeSound)
{
   filename    = "./Sound/DeathIonCannonChargeUp.wav";
   Description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(DeathIonCannonShellDebris)
{
	shapeFile = "./shapes/gunShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};


//muzzle flash effects
datablock ParticleData(DeathIonCannonFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 0.9 0.3 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 9.5;
	sizes[1]      = 10.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DeathIonCannonFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DeathIonCannonFlashParticle";
};

datablock ParticleData(DeathIonCannonSmokeParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -5.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 55;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.6 0.6 0.6 0.9";
	colors[1]     = "0.6 0.6 0.6 0.0";
	sizes[0]      = 2.15;
	sizes[1]      = 1.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DeathIonCannonSmokeEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 2.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DeathIonCannonSmokeParticle";
};
datablock ParticleData(DeathIonCannonChargeParticle1)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 55;
	lifetimeVarianceMS   = 55;
	textureName          = "./Shapes/lightningbolt";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.6 0.0 0.0 0.9";
	colors[1]     = "0.6 0.0 0.0 0.0";
	sizes[0]      = 8.15;
	sizes[1]      = 8.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DeathIonCannonChargeEmitter1)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 2.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DeathIonCannonChargeParticle1";
};

datablock ParticleData(DeathIonCannonChargeParticle2)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 0.0;
	textureName          = "base/data/particles/thinring";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "200.5 203.5 173.5 230";
	colors[1]     = "220.5 173.5 173.5 200";
	sizes[0]      = 15;
	sizes[1]      = 0.1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DeathIonCannonChargeEmitter2)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 1;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.2;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DeathIonCannonChargeParticle2";
};

//bullet trail effects
datablock ParticleData(DeathIonCannonTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 2.0;
	lifetimeMS           = 2025;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/thinRing";
	spinSpeed		= 300.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.3 0.0 0.4";
	colors[1]     = "0.1 0.0 0.0 0.0";
	sizes[0]      = 10.15;
	sizes[1]      = 12.25;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DeathIonCannonTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DeathIonCannonTrailParticle";
};


datablock ParticleData(DeathIonCannonExplosionParticle1)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 5.0;
	lifetimeMS           = 2000;
	lifetimeVarianceMS   = 200;
	textureName          = "./Shapes/Lightning";
	spinSpeed		= 1000.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.2 0.2 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 50.0;
	sizes[1]      = 55.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(DeathIonCannonExplosionEmitter1)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DeathIonCannonExplosionParticle1";
};

datablock ParticleData(DeathIonCannonPowerSurgeParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 3.0;
	constantAcceleration = 5.0;
	lifetimeMS           = 10;
	lifetimeVarianceMS   = 10;
	textureName          = "./Shapes/Lightningbolt";
	spinSpeed		= 100.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.0 0.0 0.9";
	colors[1]     = "0.5 0.0 0.0 0.0";
	sizes[0]      = 20.0;
	sizes[1]      = 1000.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(DeathIonCannonPowerSurgeEmitter)
{
   ejectionPeriodMS = 1000;
   periodVarianceMS = 2000;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DeathIonCannonPowerSurgeParticle";
};

datablock ParticleData(DeathIonCannonExplosionRingParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 5.0;
	lifetimeMS           = 40;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.2 0.5 0.0 0.5";
	colors[1]     = "0.6 0.0 0.0 0.0";
	sizes[0]      = 8;
	sizes[1]      = 13;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DeathIonCannonExplosionRingEmitter)
{
	lifeTimeMS = 500;

   ejectionPeriodMS = 0;
   periodVarianceMS = 0;
   ejectionVelocity = 20;
   velocityVariance = 5.0;
   ejectionOffset   = 10.0;
   thetaMin         = 180;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DeathIonCannonExplosionRingParticle";
};

datablock ExplosionData(DeathIonCannonExplosion)
{
   //explosionShape = "";
   explosionShape = "./shapes/DeathIonCannonLaserExplosion.dts";
	soundProfile = DeathIonCannonExplosionSound;

   lifeTimeMS = 1000;

   ParticleEmitter = DeathIonCannonExplosionEmitter1;
   particleDensity = 100;
   particleRadius = 100;

   emitter[0] = DeathIonCannonExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "10 10 10";

   shakeCamera = true;
   camShakeFreq = "34.0 38.0 34.0";
   camShakeAmp = "25.0 30.0 25.0";
   camShakeDuration = 0.5;
   camShakeRadius = 300.0;

   // Dynamic light
   lightStartRadius = 500;
   lightEndRadius = 300;
   lightStartColor = "1 0 0 0.5";
   lightEndColor = "0 0 0 0";

   damageRadius = 100;
   radiusDamage = 200;

   impulseRadius = 200;
   impulseForce = 15000;
};


datablock ProjectileData(DeathIonCannonProjectile)
{
   projectileShapeName = "./shapes/DeathIonCannonLaser.dts";
   directDamage        = 500;
   directDamageType    = $DamageType::DeathIonCannonDirect;
   radiusDamageType    = $DamageType::DeathIonCannonRadius;

   brickExplosionRadius = 100;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 120;
   brickExplosionMaxVolume = 9999;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 9999;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 1500;
   verticalImpulse	  = 3000;
   explosion           = DeathIonCannonExplosion;
   particleEmitter     = DeathIonCannonTrailEmitter;

   muzzleVelocity      = 500;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 10000;
   fadeDelay           = 3500;
   bounceElasticity    = 4;
   bounceFriction      = 6.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 20.0;
   lightColor  = "1 0 0";
};

//////////
// item //
//////////
datablock ItemData(DeathIonCannonItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shapes/DeathIonCannon.dts";
	rotate = true;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "DeathIonCannon";
	iconName = "./Shapes/DeathIonCannon";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = DeathIonCannonImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(DeathIonCannonImage)
{
   // Basic Item properties
   shapeFile = "./shapes/DeathIonCannon.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = DeathIonCannonProjectile;
   projectileType = Projectile;

	casing = DeathIonCannonShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = DeathIonCannonItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]			 = DeathIonCannonSwitchSound;

	stateName[1]                     = "Ready";
	stateEmitter[1]			 = DeathIonCannonPowerSurgeEmitter;
	stateEmitterNode[1]		 = "muzzleNode";
	stateTransitionOnTriggerDown[1]  = "Prefire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = true;
	stateSound[2]			= DeathIonCannonChargeSound;
	stateTimeoutValue[2]            = 1;
	stateTransitionOnTimeout[2]     = "DissengageLock";
	stateAllowImageChange[2]	="true";
	stateEmitter[2]			= DeathIonCannonChargeEmitter2;
	stateEmitterTime[2]		= 2;
	stateEmitterNode[2]		="muzzleNode";

	stateName[3]			= "DissengageLock";
	stateScript[3]			= "onDissengageLock";
	stateAllowImageChange[3]	= true;
	stateTimeOutValue[3]		= 2;
	stateTransitionOnTimeout[3]	= "Fire";
	stateAllowImageChange[3]	= "true";
	stateEmitter[3]			= DeathIonCannonChargeEmitter1;
	stateEmitterTime[3]		= 2;
	stateEmitterNode[3]		="muzzleNode";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "Fire2";
	stateTimeoutValue[4]            = 0.5;
	stateAllowImageChange[4]        = true;
	stateSequence[4]                = "Fire";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]		= true;
	stateFire[4]                    = true;
	stateEmitter[4]			= DeathIonCannonFlashEmitter;
	stateEmitterTime[4]		= 0.05;
	stateEmitterNode[4]		= "muzzleNode";
	stateSound[4]			= DeathIonCannonShot1Sound;

	stateName[5]                    = "Fire2";
	stateTransitionOnTimeout[5]     = "Fire3";
	stateTimeoutValue[5]            = 0.5;
	stateAllowImageChange[5]        = true;
	stateSequence[5]                = "Fire";
	stateScript[5]                  = "onFire";
	stateWaitForTimeout[5]		= true;
	stateFire[5]                    = true;

	stateEmitter[5]			= DeathIonCannonFlashEmitter;
	stateEmitterTime[5]		= 0.05;
	stateEmitterNode[5]		= "muzzleNode";
	stateSound[5]			= DeathIonCannonShot1Sound;

	stateName[6]                    = "Fire3";
	stateTransitionOnTimeout[6]     = "Fire4";
	stateTimeoutValue[6]            = 0.5;
	stateAllowImageChange[6]        = true;
	stateSequence[6]                = "Fire";
	stateScript[6]                  = "onFire";
	stateWaitForTimeout[6]		= true;
	stateFire[6]                    = true;

	stateEmitter[6]			= DeathIonCannonFlashEmitter;
	stateEmitterTime[6]		= 0.05;
	stateEmitterNode[6]		= "muzzleNode";
	stateSound[6]			= DeathIonCannonShot1Sound;

	stateName[7]                    = "Fire4";
	stateTransitionOnTimeout[7]     = "Fire5";
	stateTimeoutValue[7]            = 0.5;
	stateAllowImageChange[7]        = true;
	stateSequence[7]                = "Fire";
	stateScript[7]                  = "onFire";
	stateWaitForTimeout[7]		= true;
	stateFire[7]                    = true;

	stateEmitter[7]			= DeathIonCannonFlashEmitter;
	stateEmitterTime[7]		= 0.05;
	stateEmitterNode[7]		= "muzzleNode";
	stateSound[7]			= DeathIonCannonShot1Sound;

	stateName[8]                    = "Fire5";
	stateTransitionOnTimeout[8]     = "Smoke";
	stateTimeoutValue[8]            = 0.5;
	stateAllowImageChange[8]        = true;
	stateSequence[8]                = "Fire";
	stateScript[8]                  = "onFire";
	stateWaitForTimeout[8]		= true;
	stateFire[8]                    = true;

	stateEmitter[8]			= DeathIonCannonFlashEmitter;
	stateEmitterTime[8]		= 0.05;
	stateEmitterNode[8]		= "muzzleNode";
	stateSound[8]			= DeathIonCannonShot1Sound;

	stateName[9] 			= "Smoke";
	stateEmitter[9]			= DeathIonCannonSmokeEmitter;
	stateEmitterTime[9]		= 1;
	stateEmitterNode[9]		= "muzzleNode";
	stateTimeoutValue[9]            = 1;
	stateTransitionOnTimeout[9]     = "Reload";
	stateSound[9]			 = DeathIonCannonReloadSound;

	stateName[10]			= "Reload";
	stateSequence[10]                = "Reload";
	stateTransitionOnTriggerUp[10]     = "Ready";
	stateSequence[10]		= "Ready";

};

function DeathIonCannonImage::onPreFire(%this, %obj, %slot)
{
   if(!%obj.client.isadmin && !%obj.client.issuperadmin){
   messageclient(%obj.client,"","You are not an admin!");
   return;
   }
Parent::onPreFire(%this, %obj, %slot);
}


